local addonName = "CopyMail"
local activeMail
local copyField

local function CreateCopyField()
  local window = WINDOW_MANAGER:CreateTopLevelWindow("CopyMail")
  window:SetHidden(true)
  window.editField = WINDOW_MANAGER:CreateControl("CopyMailField", window, CT_EDITBOX )
  window.editField:SetMultiLine(true)
  window.editField:SetCopyEnabled(true)
  window.editField:SetMaxInputChars(2000)
  return window
end

local function OnMailReadable(event, mailID)
  activeMail = mailID
end

local function CopyMailContent()
  local mailBody = ReadMail(activeMail)
  copyField.editField:SetText(string.sub(mailBody, 1, 1022))
  copyField.editField:CopyAllTextToClipboard()
end

local function AddonInitialized(eventCode, addon)

  if (addon ~= addonName) then return end
  
  if MAIL_INBOX.selectionKeybindStripDescriptor then
    table.insert(MAIL_INBOX.selectionKeybindStripDescriptor, {name = "Copy Content", callback = CopyMailContent, keybind = "UI_SHORTCUT_TERTIARY"})
  end
  
  copyField = CreateCopyField()
  
  EVENT_MANAGER:RegisterForEvent(addonName, EVENT_MAIL_READABLE, OnMailReadable)

--  SLASH_COMMANDS["/accounter"] = SlashCommandHandler
end

EVENT_MANAGER:RegisterForEvent(addonName, EVENT_ADD_ON_LOADED, AddonInitialized)